
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <malloc.h>
#include <errno.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <libsmbclient.h>

#include "../smbredir/smbredir.h"
#include "../smbremote/smbc_api.h"

void smbc_auth_fn(const char *server, const char *share,
		  char *workgroup, int wgmaxlen, char *username, int unmaxlen,
		  char *password, int pwmaxlen);

int smbc_redir_thread(void *pv)
{
    int fd;
    char buf[256];
    SMBC_MSG *msg;

    printf("smbc_redir_thread: Starting\n");

    if (smbc_init(smbc_auth_fn, 0) < 0) {
	printf("smbc_redir_thread: smb init failed, error %d\n", errno);
	return -1;
    }

    fd = open("/root/smbredir0", O_RDONLY, 0);
    if (fd < 0) {
	printf("smbc_redir_thread: Can't open smbredir0 device\n");
	return -1;
    }
       
    while (1) {

	msg = &buf;
	msg->size = sizeof(buf);
	if (ioctl(fd, SMBREDIR_IOCTL_WAIT_MSG, msg) < 0)
	    break;

	if (!smbc_dispatch_msg(msg, msg))
	    break;

	if (ioctl(fd, SMBREDIR_IOCTL_REPLY_MSG, msg) < 0)
	    break;
    }

    close(fd);
    return 0;
}
	
