#include <linux/config.h>
#include <linux/ptrace.h>
#include <linux/kernel_stat.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/ioport.h>
#include <linux/interrupt.h>
#include <linux/slab.h>
#include <linux/random.h>
#include <linux/smp.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/modsetver.h>

#define SJ_TRACE_BUFFER_SIZE	(256)

typedef struct tracebufstruct {
    char *str;
    unsigned int arg;
    unsigned int pid;
    unsigned int flags;
    unsigned int sp;
    unsigned int pc;
    unsigned int lr;
} tbtype;
	
tbtype sj_trace_buffer[SJ_TRACE_BUFFER_SIZE+3];
int sj_buffer_head = 0,sj_trace_running = 1;


void sj_trace(char *str, int arg, struct pt_regs *regs)
{
#if 0    
    int flags,i;
    
    if(!sj_trace_running)
	return;

    save_and_cli(flags);
    i = sj_buffer_head;
    sj_buffer_head = (sj_buffer_head +1) % SJ_TRACE_BUFFER_SIZE;
    restore_flags(flags);
    
    sj_trace_buffer[i].str = str;
    sj_trace_buffer[i].arg = arg;
    sj_trace_buffer[i].pid = current->pid;
    
    if(regs) {
	sj_trace_buffer[i].flags = regs->ARM_cpsr;
	sj_trace_buffer[i].pc = regs->ARM_pc;
	sj_trace_buffer[i].sp = regs->ARM_sp;
	sj_trace_buffer[i].lr = regs->ARM_lr;
    } else {
	sj_trace_buffer[i].flags = current->thread.save->cpsr;
	sj_trace_buffer[i].pc = current->thread.save->pc;
	sj_trace_buffer[i].sp = current->thread.save->sl;
	sj_trace_buffer[i].lr = current->thread.save->sl;
    }
#endif    
    return;
}

void sj_dumptrace(void)
{
#if 0    
    int flags, i,j;
    char *str;
    
    j = sj_trace_running;
    sj_trace_running = 0;
    
    printk("\n\nTrace Starts\n");
    i = sj_buffer_head + 1;
    
    while(i != sj_buffer_head) {
	str = sj_trace_buffer[i].str;
	if( ((unsigned int) str < 0x90000000) || ((unsigned int) str < 0x90000000) || !*str || strlen(str) > 30) {
	    str = "invalid";
	}
        printk("%s\n      %08x, pid=%08x fl=%08x, pc=%08x sp=%08x lr=%08x\n",str,
    	    sj_trace_buffer[i].arg,
    	    sj_trace_buffer[i].pid,
    	    sj_trace_buffer[i].flags,
	    sj_trace_buffer[i].pc,
	    sj_trace_buffer[i].sp,
	    sj_trace_buffer[i].lr);
  		
	++i;
	if(i >= SJ_TRACE_BUFFER_SIZE)
	    i = 0;
    }
    sj_trace_running = j;
    
    printk("\nTrace Ends\n\n");
#endif    
}

EXPORT_SYMBOL_NOVERS(sj_trace);
