#include <linux/config.h>
#include <linux/module.h>
#include <linux/modsetver.h>

extern void sj_trace(char *str, int arg, struct pt_regs *regs);
extern void sj_memcpy(void *to, const void *from, __kernel_size_t count);

asmlinkage void memcpy(void *to, const void *from, __kernel_size_t count)
{
    sj_trace("memcpy ",(int) to, 0);
    
    if( ((int) to < 0x90000000) || ((int) to > 0xa0000000) || ((int) from < 0x90000000) || ((int) from > 0xa0000000) || 
	    (count > 0x01000000) || (count < 4)) {
	printk("\n\nMemcpy Warning: to: %p   from %p   count %08lx \n\n",to, from, count);
    }
    sj_memcpy(to, from, count);
}

asmlinkage void memmove(void *to, const void *from, __kernel_size_t count)
{
    sj_trace("memmove ",(int) to, 0);
    
    if( ((int) to < 0x90000000) || ((int) to > 0xa0000000) || ((int) from < 0x90000000) || ((int) from > 0xa0000000) || 
	    (count > 0x01000000) || (count < 4)) {
	printk("\n\nMemcpy Warning: to: %p   from %p   count %08lx \n\n",to, from,count);
    }
    sj_memcpy(to, from, count);
}

EXPORT_SYMBOL_NOVERS(memcpy);
EXPORT_SYMBOL_NOVERS(memmove);
