/*
 * arch/arm/mach-em86xx/splash.c
 *
 * Copyright (C) 2006 SkipJam Corp.
 */

#define ALLOW_OS_CODE 1

#include "/opt/sigma/mrua_2.6.115.0_dev.arm/MRUA_src/emhwlib/include/emhwlib.h"
#include "/opt/sigma/mrua_2.6.115.0_dev.arm/MRUA_src/emhwlib/include/emhwlib_properties_1000.h"
#include "/opt/sigma/mrua_2.6.115.0_dev.arm/MRUA_src/emhwlib/include/emhwlib_event.h"
#include "/opt/sigma/mrua_2.6.115.0_dev.arm/MRUA_src/emhwlib/include/emhwlib_chipspecific.h"

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <asm/hardware.h>
#include <asm/io.h>
#include <asm/arch/em86xxapi.h>
#include <linux/irq.h>
#include <linux/sched.h>

extern struct file_operations em8xxx_fops;

struct inode em8xxx_inode;

RMuint32 DCCSP(RMuint32 pRUA, RMuint32 moduleID, RMuint32 propertyID, void *pValue, RMuint32 valueSize)
{
    struct RUAEvent evt;
    RMstatus err;
    RMuint32 n;

    n = 5;
    do {
	evt.Mask = EMHWLIB_DISPLAY_EVENT_ID(moduleID);
	if (evt.Mask > 0) {
	    evt.ModuleID = EMHWLIB_MODULE(DisplayBlock, 0);
	    err = RUAResetEvent(pRUA, &evt);
	    if (RMFAILED(err)) {
		printk("Cannot reset display event, %x\n", err);
		return err;
	    }
	}
	err = RUASetProperty(pRUA, moduleID, propertyID, pValue, ValueSize, 0);
	if ((err == RM_PENDING) && (evt.Mask > 0)) {
	    RMuint32 index;
	    err = RUAWaitForMultipleEvents(pRUA, &evt, 1, WAIT_COMMAND_TIMEOUT_US, &index);
	    if (RMFAILED(err)) {
		printk("wait for display update event completion failed, %x\n", err);
		if (err != RM_PENDING) return err;
	    }
	    err = RUASetProperty(pRUA, moduleID, propertyID, pValue, ValueSize, 0);
	}
	if (err == RM_PENDING) {
	    printk("Property %d on module %d still pending, trying again...\n", propertyID, moduleID);
	}
	n--;
    } while ((n > 0) && (err == RM_PENDING));
    if (err != RM_OK) {
	printk("Property %d on module %d, %x\n", propertyID, moduleID, err);
	return err;
    }
    return err;
}

RMstatus DCCInitChainEx(struct DCC *pDCC, enum DCCInitMode init_mode)
{
    	RMstatus err;
	RMuint32 mixer, scaler, surface;
	enum EMhwlibColorSpace colorspace;

	mixer = EMHWLIB_MODULE(DispMainMixer, 0); 
	scaler = EMHWLIB_MODULE(DispMainVideoScaler, 0);

	colorspace = EMhwlibColorSpace_None;  // allow mixer color space to be set automatically
	DCCSP(pDCC->pRUA, mixer, RMGenericPropertyID_ColorSpace, &colorspace, sizeof(colorspace));

	return RM_OK;
}

int RUACreateInstance(uint32 *pRUA, int chip_num)
{
    struct file filp;
    int status;

    em8xxx_inode.i_rdev = 0;
    status = em8xxx_fops.open(&em8xxx_inode, &filp);
    if (0 != status) {
	printk("Failed to open driver, error %d\n", status);
	return status;
    }

    return status;
}
