/*
 * include/asm-arm/arch-em86xx/board-generic/mtdpartitions.h
 *
 * Copyright (C) 2003-2004 Sigma Designs, Inc
 * 
 * Sigma Designs Evaluation Boards
 */

#ifndef __ASM_ARCH_BOARD_MTDPARTITIONS_H
#define __ASM_ARCH_BOARD_MTDPARTITIONS_H

#include <asm/arch/boardname.h>

#ifdef CONFIG_MTD_PARTITIONS

//        size: EM86XX_FLASH_SIZE - (0x10000+0x20000+EM86XX_GZ_KERNEL_SIZE), 

#define EM86XX_FLASH_SIZE 8*1024*1024    
//#define EM86XX_GZ_KERNEL_SIZE (1664)*1024
//#define EM86XX_GZ_KERNEL_SIZE (1728)*1024
//#define EM86XX_GZ_KERNEL_SIZE (1792)*1024
#define EM86XX_GZ_KERNEL_SIZE (1920)*1024
#define EM86XX_MTD_PARTITIONS \
    { /* 64KB readonly: first stage bootloader */ \
        name: "BootROM1", \
        size: 0x10000, \
        offset: 0x0, \
        mask_flags: MTD_WRITEABLE, /* Not writable */ \
    }, \
    { /* 128KB: second stage bootloader */ \
        name: "BootROM2", \
        size: 0x20000, \
        offset: 0x10000, \
        mask_flags: MTD_WRITEABLE, \
    }, \
    /* 128KB: second stage bootloader */  \
    { /* Partition for Kernel */ \
        name: "GZKernel", \
        size: EM86XX_GZ_KERNEL_SIZE, \
        offset: 0x10000 + 0x20000, \
        mask_flags: 0, /* Not writable */ \
    }, \
    { /* 64KB read/write */ \
        name: "JFSS2", \
        size: ((EM86XX_FLASH_SIZE)-(EM86XX_GZ_KERNEL_SIZE)-0x20000-0x10000-0x10000), \
        offset: (0x10000+0x20000+(EM86XX_GZ_KERNEL_SIZE)), \
        mask_flags: 0, \
    },
#endif

#endif
